=== debian/changelog ===
obs-studio (30.1.2-0.nmu1) UNRELEASED; urgency=medium

  * Non-maintainer upload.
  * new upstream version 30.1.2
  * debian-patches/:
    skip 0006-Do-not-build-unused-blake2-dependency.patch
    skip 0013-Fix-comparision-if-char-is-unsigned.patch
  * disable:
    DeckLink
    JACK

 -- Roman Vasiyarov <rvasiyarov@gmail.com>  Sat, 27 Apr 2024 23:24:00 +0300
